//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 7: L�sung eines mathematischen Anwendungsproblems
//
// Datei:  Cramer.cpp
// Inhalt: Cramer-Klasse
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "Cramer.h"
#include "QMatrix.h"
#include "Vektor.h"
#include <cmath>

//////////////////////////////////////////////////////////////////////////////
///////////////////////// Funktions-Implementierung //////////////////////////
//////////////////////////////////////////////////////////////////////////////

Cramer::Cramer(int dim)
{
	x = new Vektor(dim);
}

//////////////////////////////////////////////////////////////////////////////
Vektor Cramer::loese(QMatrix A, Vektor b)
{
	int dim = A.getDim();
	double det = A.determinante();

	for (int l = 0; l < dim; l++)
	{
		QMatrix Ai = A;
		for (int k = 0; k < dim; k++) /* konstruiere Ai: i-te Spalte wird durch b ersetzt */
		{
			Ai.set(k, l, b.get(k));
		}

		x->set(l, Ai.determinante() / det);
	}

	return *x;
}
